#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include "E:\libfelicalite\felicalib.h"
#include <conio.h>

/*
DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
Version 2, December 2004

Copyright (C) 2017 GPS_NMEA_JP

Everyone is permitted to copy and distribute verbatim or modified
copies of this license document, and changing it is allowed as long
as the name is changed.

DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. You just DO WHAT THE FUCK YOU WANT TO.
*/

void hexdump(uint8 *addr, int n)
{
	for (int i=0;i<n;i++)
		printf("%02X ", addr[i]);
	printf("\n");
}

int _main()
{
	int mode,valh,vall;
	system("cls");
	printf("--- Quartz Pay ---\n");
	printf("[1]チャージ\n");
	printf("[2]支払い\n");
	int c = _getche();

	if(c!='1'&&c!='2')
		return 0;

	printf("\n金額を入力:");
	int val;
	scanf("%d", &val);

	valh = (val >> 8) & 0xFF;
	vall = val & 0xFF;
	if(c=='1')
	{
		mode = 0x00;
	}else if ( c == '2' )
	{
		mode = 0x01;
	}else{
		return 0;
	}


	// --- PaSoRiを開く --- 
	pasori *p = pasori_open();
	if (p == NULL)
	{
		printf("Felicaライブラリがオープンできませんでした\n");
		return -1;
	}

	// --- PaSoRiを初期化 --- 
	if (pasori_init(p) != 0)
	{
		printf("PaSoRiが開けませんでした．(使用中or未接続)\n");
		return -1;
	}

	// --- カードを検出 --- 
	felica *f = NULL; //fハンドル
	while ( !f )
	{
		printf("カードを探しています...\r");
		f = felica_polling(p, 0x40FF, 0);
	}

	// --- pollingで得られた情報 --- 
	printf("カードが見つかりました\n");
	printf("# IDm: "); hexdump(f->IDm, 8);
	printf("# PMm: "); hexdump(f->PMm, 8);

	// --- 読み出し --- 
	UINT8 readData[16]={0};
	int readCode = felica_read_without_encryption03(f, SERVICECODE_RO, 0x1780, readData);
	if ( !readCode )
	{
		printf("# Read: "); hexdump(readData, 16);
	}else{
		printf("# Read Error %X\n", readCode);
		print_response_error(readCode);
	}
	int value = readData[0]<<8 | readData[1];
	printf("処理前のポイント:%d\n",value);


	// --- 書き込み --- 
	UINT8 writeData[16] = {mode,valh,vall};
	int writeCode = felica_write_without_encryption03(f, SERVICECODE_RW, 0x1780, writeData);
	if ( !writeCode )
	{
		printf("# Write: "); hexdump(writeData, 16);
	} else
	{
		printf("# Write Error %X\n", readCode);
		print_response_error(writeCode);
	}

	// --- 読み出し --- 
	readCode = felica_read_without_encryption03(f, SERVICECODE_RO, 0x1780, readData);
	if ( !readCode )
	{
		printf("# Read: "); hexdump(readData, 16);
	} else
	{
		printf("# Read Error %X\n", readCode);
		print_response_error(readCode);
	}
	value = readData[0] << 8 | readData[1];
	printf("処理後のポイント:%d\n", value);

	// --- 終了処理 --- 
	felica_free(f);
	pasori_close(p);

	printf("続けるには何かキーを押してください\n");
	_getche();
	return 0;

}

int main()
{
	while ( 1 )
	{
		_main();
	}
}